﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Threading;
using Microsoft.Office.Interop.Excel;

namespace FindData4
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        #region 变量申明

        private int m_filesCount;// 文件总数量
        private BackgroundWorker m_bgworker = null;// 后台线程
        private DirectoryInfo m_dirInfo = null;// 目录信息

        private System.Data.DataTable dt;
        private List<string> m_FileNames = new List<string>();
        private List<string> inputFiles = new List<string>();//从文本文档中读取到的文件列表
        private List<string> targetPth = new List<string>();//搜索路径
        DateTime beginTime;//开始时间
        DateTime endTime;//结束时间

        #endregion

        #region 搜索前
        //获取文件名的list
        private List<string> GetListOfFiles()
        {
            List<string> list = new List<string>();

            FileStream ifs = new FileStream(tb_selectFile.Text, FileMode.Open);
            //FileStream ifs = new FileStream(@"..\..\DllList.txt", FileMode.Open);//打开数据文件
            StreamReader sr = new StreamReader(ifs);
            while (!sr.EndOfStream)
            {
                list.Add(sr.ReadLine());
            }
            ifs.Close();
            sr.Close();
            return list;
        }

        //选择被查找的文本文件
        private void btn_selectFile_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            if (openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                //if()
                string fileName = openFileDialog1.FileName;
                string ext = fileName.Substring(fileName.LastIndexOf(".") + 1);
                if (ext != "txt")
                {
                    MessageBox.Show("please choose txt files");
                    tb_selectFile.Text = "";
                }
                tb_selectFile.Text = openFileDialog1.FileName;
            }
        }

        private void btn_choosePath_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog folderBrowserDialog1 = new FolderBrowserDialog();
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                tb_path.Text = folderBrowserDialog1.SelectedPath;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (tb_path.Text != "")
            {
                //listBox1.Text += ;
                listBox1.Items.Add(tb_path.Text);
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (listBox1.SelectedIndex > -1)
            {
                listBox1.Items.Remove(listBox1.Items[listBox1.SelectedIndex]);
            }
        }  
        #endregion

        #region 开始处理

        //开始处理
        private void btnProcess_Click(object sender, EventArgs e)
        {
            //do the check
            if (tb_selectFile.Text == "")
            {
                MessageBox.Show("make sure that file is not empty!");
                return;
            }

            beginTime = DateTime.Now;
            m_FileNames.Clear();
            inputFiles.Clear();
            inputFiles = GetListOfFiles();//获取文件名的list
            targetPth.Clear();
            rtxtResult.Text = "";
            string systempath=Environment.ExpandEnvironmentVariables("%SystemDrive%"); //系统盘符
            

            //targetPth.Add(systempath + @"\Program Files");
            //targetPth.Add(systempath + @"\Program Files (x86)");
            //targetPth.Add(systempath + @"\"+programPath+@"\Reference Assemblies\Microsoft");
            //targetPth.Add(systempath + @"\"+programPath86 +@"\Reference Assemblies\Microsoft");
            //targetPth.Add(systempath + @"\"+programPath+@"\Microsoft Visual Studio 10.0\Common7\IDE");
            //targetPth.Add(systempath + @"\"+programPath86+@"\Microsoft Visual Studio 10.0\Common7\IDE");
            //targetPth.Add(systempath + @"\"+programPath+@"\Microsoft Visual Studio 9.0\Common7\IDE");
            //targetPth.Add(systempath + @"\"+programPath86+@"\Microsoft Visual Studio 9.0\Common7\IDE");

            if (tb_path.Text == "")//如果路径为空，则默认为系统路径
            {
                targetPth.Add(systempath);
            }
            else//否则，根据所添加的路径，将相应的值添加的搜索路径中
            {
                //targetPth.Add(tb_path.Text);
                if (listBox1.Items.Count == 0)
                {
                    targetPth.Add(tb_path.Text);
                }
                else
                {
                    for (int i = 0; i < listBox1.Items.Count; i++)
                    {
                        targetPth.Add(listBox1.Items[i].ToString());
                    }
                }
            }

            m_filesCount = 0;//找到的文件个数
            dt = new System.Data.DataTable();//存储扫描到的结果
            dt.Columns.Add("filename");dt.Columns.Add("filepath");
            dataGridView1.DataSource = dt;
            dataGridView1.AutoResizeColumns();
            m_bgworker = new BackgroundWorker();
            m_bgworker.WorkerReportsProgress = true;
            m_bgworker.WorkerSupportsCancellation = true;
            m_bgworker.DoWork += new DoWorkEventHandler(DoWork);
            m_bgworker.ProgressChanged += new ProgressChangedEventHandler(ReportProgress);
            m_bgworker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(RunWorkerCompleted);
            m_bgworker.RunWorkerAsync();
        }

        private void DoWork(object sender, DoWorkEventArgs dwea)
        {
            BackgroundWorker _worker = sender as BackgroundWorker;
            for (int i = 0; i < targetPth.Count; i++)
            {
                ErgodicFile(_worker, targetPth[i].ToString());
            }  
        }

        /// <summary>
        /// 计算所花费的时间
        /// </summary>
        /// <param name="DateTime1"></param>
        /// <param name="DateTime2"></param>
        /// <returns></returns>
        private string DateDiff(DateTime DateTime1, DateTime DateTime2)
        {
            string dateDiff = null;
            TimeSpan ts1 = new TimeSpan(DateTime1.Ticks);
            TimeSpan ts2 = new TimeSpan(DateTime2.Ticks);
            TimeSpan ts = ts1.Subtract(ts2).Duration();
            dateDiff = ts.TotalSeconds.ToString();
            return dateDiff;
        }

        /// <summary>
        /// 处理搜索到的数据
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ReportProgress(object sender, ProgressChangedEventArgs e)
        {
            string _fileName = e.UserState.ToString();
            string resultpath = _fileName + System.Environment.NewLine;
            string resultname = resultpath.Substring(resultpath.LastIndexOf("\\") + 1);
            rtxtResult.AppendText(_fileName + System.Environment.NewLine);
            DataRow dr = dt.NewRow();

            dr["filename"] = resultname;
            dr["filepath"] = resultpath;
            dt.Rows.Add(dr);
            dataGridView1.AutoResizeColumns();
            rtxtResult.ScrollToCaret();
            lblCount.Text = (rtxtResult.Lines.Length - 1).ToString();
        }

        private void RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            endTime = DateTime.Now;
            string timediff = DateDiff(beginTime, endTime);//求运行时间
            if (DialogResult.OK == MessageBox.Show("Scan comleted! There is " + m_FileNames.Count + " Files in total ，spend time:" + timediff + " seconds,please check", "Done!", MessageBoxButtons.OKCancel))
            { }
        }

        /// <summary>
        /// 停止查找
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnStop_Click(object sender, EventArgs e)
        {
            if (m_bgworker != null && m_bgworker.WorkerSupportsCancellation)
            {
                m_bgworker.CancelAsync();
            }
        }
        #endregion

        #region 核心函数  遍历所有路径

        /// <summary>
        /// 遍历指定路径下所有指定名的文件
        /// </summary>
        /// <param name="path">指定路径</param>
        /// <param name="ext">文件扩展名,不包含分隔符(.)</param>
        /// <returns>返回所有文件绝对路径</returns>
        private void ErgodicFile(BackgroundWorker worker, string path)
        {
            //如果取消则停止查找
            if (worker.CancellationPending)
            {
                return;
            }

            Thread.Sleep(1);
            FileSystemInfo[] _fsi = null;//存储目录下的文件信息
            try
            {
                m_dirInfo = new DirectoryInfo(path);
                _fsi = m_dirInfo.GetFileSystemInfos();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                return;
            }

            FileInfo _fi;
            try
            {
                for (int i = 0; i < _fsi.Length && !worker.CancellationPending; i++)
                {
                    if (!Directory.Exists(_fsi[i].FullName))
                    {//是文件
                        _fi = new FileInfo(_fsi[i].FullName);
                        //判断文件扩展名
                        if (cb_ext.Checked)
                        {
                            
                            if (_fi.Extension == tb_ext.Text.ToString())
                            {//要求文件名
                                for (int j = 0; j < inputFiles.Count; j++)
                                {
                                    //忽略大小写，进行字符串比较
                                    //if (string.Equals(_fi.Name,inputFiles[j].ToString() + ".xml",StringComparison.OrdinalIgnoreCase))
                                    if (string.Equals(_fi.Name, inputFiles[j].ToString() + tb_ext.Text.ToString(), StringComparison.OrdinalIgnoreCase))
                                    {
                                        m_filesCount++;
                                        worker.ReportProgress(0, _fi.FullName);//处理相应的文件
                                        m_FileNames.Add(_fi.FullName);
                                        Thread.Sleep(10);
                                    }
                                }
                            }
                        }
                        else
                        {
                            for (int j = 0; j < inputFiles.Count; j++)
                            {
                                //忽略大小写，进行字符串比较
                                //if (string.Equals(_fi.Name,inputFiles[j].ToString() + ".xml",StringComparison.OrdinalIgnoreCase))
                                if (string.Equals(_fi.Name, inputFiles[j].ToString(), StringComparison.OrdinalIgnoreCase))
                                {
                                    m_filesCount++;
                                    worker.ReportProgress(0, _fi.FullName);//处理相应的文件
                                    m_FileNames.Add(_fi.FullName);
                                    Thread.Sleep(10);
                                }
                            }
                        }

                        
                    }
                    else
                    {//是目录,继续遍历
                        ErgodicFile(worker, _fsi[i].FullName);
                        Thread.Sleep(1);
                    }
                    Thread.Sleep(1);
                }
                Thread.Sleep(1);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        #endregion

        #region 数据输出

        private void btnStart_Click(object sender, EventArgs e)
        {
            string desktop = Environment.GetFolderPath(Environment.SpecialFolder.Desktop).ToString();
            DataTabletoExcel(dt, desktop + "\\Data.xlsx");
            MessageBox.Show("Data has been save to desktop，please check!");
        }

        /// <summary>
        /// 将datatable转成excel
        /// </summary>
        /// <param name="tmpDataTable"></param>
        /// <param name="strFileName"></param>
        public static void DataTabletoExcel(System.Data.DataTable tmpDataTable, string strFileName)
        {
            if (tmpDataTable == null)
                return;
            int rowNum = tmpDataTable.Rows.Count;
            int columnNum = tmpDataTable.Columns.Count;
            int rowIndex = 1;
            int columnIndex = 0;
            Microsoft.Office.Interop.Excel.Application xlApp = new Microsoft.Office.Interop.Excel.Application();
            xlApp.DefaultFilePath = "";
            xlApp.DisplayAlerts = true;
            xlApp.SheetsInNewWorkbook = 1;
            Workbook xlBook = xlApp.Workbooks.Add(true);
            //将DataTable的列名导入Excel表第一行
            foreach (DataColumn dc in tmpDataTable.Columns)
            {
                columnIndex++;
                xlApp.Cells[rowIndex, columnIndex] = dc.ColumnName;
            }
            //将DataTable中的数据导入Excel中
            for (int i = 0; i < rowNum; i++)
            {
                rowIndex++;
                columnIndex = 0;
                for (int j = 0; j < columnNum; j++)
                {
                    columnIndex++;
                    xlApp.Cells[rowIndex, columnIndex] = tmpDataTable.Rows[i][j].ToString();
                }
            }
            //xlBook.SaveCopyAs(HttpUtility.UrlDecode(strFileName, System.Text.Encoding.UTF8));
            xlBook.SaveCopyAs(strFileName);
        }

        private void btn_out4txt_Click(object sender, EventArgs e)
        {
            WriteTxt(dt);
            MessageBox.Show("Data has been save to desktop，please check!");
        }

        //把收集的信息写道txt中
        private void WriteTxt(System.Data.DataTable dt)
        {
            string desktop = Environment.GetFolderPath(Environment.SpecialFolder.Desktop).ToString();//桌面
            StreamWriter sw = File.CreateText(desktop + @"\Data.txt");
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                sw.Write(cleanString(dt.Rows[i]["filename"].ToString()) + "\t");
                sw.WriteLine(cleanString(dt.Rows[i]["filepath"].ToString()));
            }
            sw.Close();
        }

        private string cleanString(string newStr)
        {
            string tempStr = newStr.Replace((char)13, (char)0);
            return tempStr.Replace((char)10, (char)0);
        }
        #endregion




    }
}
